import { __decorate, __metadata } from 'tslib';
import { Directive, Input, ViewChild, ContentChild, ElementRef, Component, NgModule } from '@angular/core';
import { ExpInputError, CdkExpandableInputComponent, ExpandableInputModule } from '@ng-expandable-input/cdk';
import { CommonModule } from '@angular/common';

var ExpInputBootstrapDirective = /** @class */ (function () {
    function ExpInputBootstrapDirective() {
    }
    ExpInputBootstrapDirective = __decorate([
        Directive({
            selector: '[btsExpInput]'
        })
    ], ExpInputBootstrapDirective);
    return ExpInputBootstrapDirective;
}());

var ExpIconCloseBootstrapDirective = /** @class */ (function () {
    function ExpIconCloseBootstrapDirective() {
    }
    ExpIconCloseBootstrapDirective = __decorate([
        Directive({
            selector: '[btsExpIconClose]'
        })
    ], ExpIconCloseBootstrapDirective);
    return ExpIconCloseBootstrapDirective;
}());

var ExpIconOpenBootstrapDirective = /** @class */ (function () {
    function ExpIconOpenBootstrapDirective() {
    }
    ExpIconOpenBootstrapDirective = __decorate([
        Directive({
            selector: '[btsExpIconOpen]'
        })
    ], ExpIconOpenBootstrapDirective);
    return ExpIconOpenBootstrapDirective;
}());

var ExpandableInputBootstrapComponent = /** @class */ (function () {
    function ExpandableInputBootstrapComponent() {
        this.isAbsolute = false;
        this.right = 0;
        this.slideToEdge = false;
        this.isOpen = false;
    }
    ExpandableInputBootstrapComponent.prototype.ngOnInit = function () {
        this.sanityCheck();
    };
    ExpandableInputBootstrapComponent.prototype.opened = function () {
        this.isOpen = true;
    };
    ExpandableInputBootstrapComponent.prototype.closed = function () {
        this.isOpen = false;
    };
    ExpandableInputBootstrapComponent.prototype.sanityCheck = function () {
        if (!this.expandableInputRef) {
            throw new ExpInputError('You need to include an element with attribute btsExpInput');
        }
        if (!this.iconOpen) {
            throw new ExpInputError('You need to include an element with attribute btsExpIconOpen');
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ExpandableInputBootstrapComponent.prototype, "group", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ExpandableInputBootstrapComponent.prototype, "isAbsolute", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ExpandableInputBootstrapComponent.prototype, "right", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], ExpandableInputBootstrapComponent.prototype, "slideToEdge", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ExpandableInputBootstrapComponent.prototype, "openOnKey", void 0);
    __decorate([
        ViewChild(CdkExpandableInputComponent, { static: false }),
        __metadata("design:type", CdkExpandableInputComponent)
    ], ExpandableInputBootstrapComponent.prototype, "cdk", void 0);
    __decorate([
        ContentChild(ExpInputBootstrapDirective, { read: ElementRef, static: true }),
        __metadata("design:type", ElementRef)
    ], ExpandableInputBootstrapComponent.prototype, "expandableInputRef", void 0);
    __decorate([
        ContentChild(ExpIconCloseBootstrapDirective, { read: ElementRef, static: true }),
        __metadata("design:type", ElementRef)
    ], ExpandableInputBootstrapComponent.prototype, "iconClose", void 0);
    __decorate([
        ContentChild(ExpIconOpenBootstrapDirective, { read: ElementRef, static: true }),
        __metadata("design:type", ElementRef)
    ], ExpandableInputBootstrapComponent.prototype, "iconOpen", void 0);
    ExpandableInputBootstrapComponent = __decorate([
        Component({
            selector: 'bts-expandable-input',
            template: "<cdk-expandable-input\r\n  [group]=\"group\"\r\n  [isAbsolute]=\"isAbsolute\"\r\n  [right]=\"right\"\r\n  [slideToEdge]=\"slideToEdge\"\r\n  [actionOffset]=\"9\"\r\n  [openOnKey]=\"openOnKey\"\r\n  (opened)=\"opened()\"\r\n  (closed)=\"closed()\"\r\n>\r\n  <div cdkExpInput>\r\n    <ng-content select=\"[btsExpInput]\"></ng-content>\r\n  </div>\r\n\r\n  <div cdkExpIconOpen>\r\n    <ng-content select=\"[btsExpIconOpen]\"></ng-content>\r\n  </div>\r\n  \r\n  <div cdkExpIconAction>\r\n    <ng-content select=\"[btsExpIconAction]\"></ng-content>\r\n  </div>\r\n  \r\n  <div cdkExpIconClose *ngIf=\"iconClose; else defaultIconClose\">\r\n    <ng-content select=\"[btsExpIconClose]\"></ng-content>\r\n  </div>\r\n\r\n  <ng-template #defaultIconClose>\r\n    <i cdkExpIconClose class=\"fas fa-times\"></i>\r\n  </ng-template>\r\n</cdk-expandable-input>\r\n",
            styles: ["cdk-expandable-input{background-color:#fff}cdk-expandable-input::ng-deep .input-field{height:44px!important}cdk-expandable-input::ng-deep .input-field [cdkExpInput]{left:3px;top:3px;width:calc(100% - 8px)}"]
        })
    ], ExpandableInputBootstrapComponent);
    return ExpandableInputBootstrapComponent;
}());

var ExpandableInputBootstrapModule = /** @class */ (function () {
    function ExpandableInputBootstrapModule() {
    }
    ExpandableInputBootstrapModule = __decorate([
        NgModule({
            imports: [
                CommonModule,
                ExpandableInputModule
            ],
            declarations: [
                ExpandableInputBootstrapComponent,
                ExpInputBootstrapDirective,
                ExpIconOpenBootstrapDirective,
                ExpIconCloseBootstrapDirective
            ],
            exports: [
                ExpandableInputModule,
                ExpandableInputBootstrapComponent,
                ExpInputBootstrapDirective,
                ExpIconOpenBootstrapDirective,
                ExpIconCloseBootstrapDirective
            ]
        })
    ], ExpandableInputBootstrapModule);
    return ExpandableInputBootstrapModule;
}());

/*
 * Public API Surface of ng-expandable-input-bootstrap
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ExpIconCloseBootstrapDirective, ExpIconOpenBootstrapDirective, ExpInputBootstrapDirective, ExpandableInputBootstrapComponent, ExpandableInputBootstrapModule };
//# sourceMappingURL=ng-expandable-input-bootstrap.js.map
